.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive
;#########################################################################
include MacroLend.inc
;#########################################################################
.data
TitleMsg1	db ' for Micro Loan ver 1.0',0
TitleMsg2	db 'Draakie & Hubby - MASM32/RADASM',13,10
			db 'XXXRichEdit/Chib&amdtm - FPULib/R.Filiatreault',0
Password	db '1234',0			
ValidCHAR   db 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',0
ADate		db 'ddMMyyyy',0
BDate		db 'yyyyMMdd',0
Brnchfile	db 'BRANCH.dat',0  
Stockfile	db 'STOCKF.dat',0
Logfile		db 'LOGFLE.dat',0
Accfile		db 'ACCFLE.dat',0
Trnfile		db 'TRNSFL.dat',0
Richfile	db 'RICHED32.DLL',0
T_Zero	 	db '0.00',0
FontNameA	db 'Tahoma',0
;---------------------------------
; Some Richedit & ListView control frames
;---------------------------------
hRchrg  	CHARRANGE 	<?>
lf          LOGFONT    	<?>
CharF		CHARFORMAT  <?>
iccex		INITCOMMONCONTROLSEX <?>
lvi 		LV_ITEM <LVIF_TEXT,0,0,0,LVNI_FOCUSED,TmpString,30,1,0,0>
;---------------------------------
;PRINT STUFF in allmost random order  ;-)
;---------------------------------
C_omma   	db ',',0
F_slash		db '/',0
S_perate	db 9,9,0
S_Space		db 32,32,32,0
C_return	db 13,10,0
Y_Yes		db 'YES',0
N_No		db 'NO',0
ATab		db 9,0
ASep		db '_',0
ASpace		db 32,32,32,32,0
ANewline	db 13,10,0
ATabStops   dd 170,230,290,350
;---------------------------------
pINV   db 'Loan Invoice # ',0
pCLNT1 db 'Debtor ',0
pREP   db 'Consultant ',0
pSTM   db 'Cash Flow Statement / Due Check Sheet',0 
pCHP   db 'CASH-UP REPORT',0
;---------------------------------
pC_1   db 'Loan Amnt',0
pC_2   db '@ Rate',0
pC_3   db 'Balance',0
pC_4   db 'Installmnt/ Month',0
pC_5   db 'Account # ',0
pC_6   db 'I / We declare :',13,10,13,10
	   db '1. Receipt of this document describing the loan transaction requested.',13,10
	   db '2. The details of the document to be truthfull and correct.',13,10 
	   db '3. Receipt of the loan amount described in the document.',13,10 
	   db '4. Re-affirmation of my / our contractual obligations to the',13,10
   	   db '   issuer, as described in my / our Contract Document.',13,10 
	   db '5. Forthwith, I am / We are thus contractually indebted for',13,10
	   db '   the total amount due as described in this document.',13,10,13,10
	   db 'Signed  (account holder).............................. ',13,10,13,10
	   db 'Witness .............................. ',13,10,13,10 
	   db 'Date .............................. ',0
;---------------------------------	   
pPAY   db 'Receipt no #', 0
pP_1   db 'Receipt Amnt',0
pP_2   db 'Installment',0
pP_3   db 'Months left',0
pRPT   db 'Account Detail Report',0
;---------------------------------
RP1		db 'Surname    ',0
RP2		db 'Name       ',0
RP3		db 'ID Numb    ',0
RP4		db 'Address1   ',0
RP5		db 'Address2   ',0
RP6		db 'Address3   ',0
RP7		db 'Suburb     ',0
RP8		db 'City       ',0
RP9		db 'Tel  num   ',0
RP10	db 'Cell num   ',0
RP11	db 'Bank       ',0
RP12	db 'Card no    ',0
RP13	db 'Kin1       ',0
RP14	db 'Kin1 Tel   ',0
RP15	db 'Kin2       ',0
RP16	db 'Kin2 Tel   ',0
RP17	db 'Invoice #  ',0
RP18	db 'Date Start ',0
RP19	db 'Date End   ',0
RP20	db 'L.Receipt #',0
RP21	db 'Loan Amnt  ',0
RP22	db 'Loan Rate  ',0
RP23	db 'Balance    ',0
RP24	db 'Installment',0
RP25	db 'Mnths Left',0
RP26	db 'Total Owed Due Amount	:',0
RP27    db 'Total Due Installments	:',0
RP28a   db 'Profit Projected /Month	:',0
RP28b	db 'Total Amount on Loan	:',0
RP29a	db 'Number of Due Accounts	: ',0
RP29b   db 'Number of Active Accounts	: ',0
RP30	db 'Due Date',0
RP31	db 'Inv #',0
;---------------------------------
PCH1	db 'Ending Stock Value	: ',0
PCH2	db 'Starting Stock Value	: ',0
PCH3	db 'Number of Payments/Shift	: ',0
PCH4	db 'Number of New Accnts/Shift	: ',0
PCH5	db 'Number of Invoices/Shift	: ',0
PCH6	db 'Stock Movement	: ',0
;---------------------------------
Header1 db 'Invoice #',0
Header2 db 'Installment  ',0
Header3 db 'Balance Owing',0
Header4 db 'Months Left  ',0	   
;---------------------------------
; Some Vars that need initial Values
;---------------------------------
ALIGN 4
OneHundred  REAL10 100.00   ;  - quick load for FPU percentage calcs
DB_END		dd 0			;  }
IBrnch		db 0			;  }
IStock		db 0			;  } status checking on initialization
IAccnt		db 0			;  }
;----------------------------------
; Message box text informing of imminent dooms-day stuff
;----------------------------------
ErrorA  db 'Event notification',0
Error1	db 'All fields must contain data',13,10
	  	db 'and must be of a valid type',13,10
	  	db 'All Standard fields >= 3 chars',13,10
	  	db 'Others:Card number >= 5 digits',13,10
	  	db 'ID = 13 digits / Tel = 10 digits',0
Error1b db 'Duplicate Account with ID found',13,10
		db 'Possible Fraudulent Transaction!',0
Error2	db 'Update Logged Successfully',0
Error3a db 'Are you sure ? ',13,10
Error3x db 'Stock IN '
Error3A db 50 dup (0)
Error3b db 'Are you sure ? ',13,10
Error3y db 'Stock OUT '
Error3B db 50 dup (0)
Error3c db ' units - ',0
Error4	db 'Canceled !',0
Error5	db 'Negative Stock Value not allowed',0
Error6	db 'Shift in progress, do you wish to',13,10
		db 'shift-end and cashup as consultant',13,10
Error6a db 30 dup (0)
Error7  db 'Are you sure ?',13,10,'Quit Application',0
Error8	db 'File I/O or Memmory allocation Failure',0
Error9  db 'Are you sure ?',13,10,'Add NEW Client Detail',0
Error9a db 'Are you sure ?',13,10,'Re/Submit Client Detail',0
Error9b db 'Are you sure ?',13,10,'Invoice Account Holder',0
Error10 db 'Sorry - not found',0
Error10_2	db '  Last chance : is Printing complete ?!',13,10
			db '   * Very NB : Double check please ! * ',0
Error11 db '<Transaction requirements were not met>',13,10
		db '1. Select Account, Date range & Loan', 13,10
		db '   details first ex.Find/Amnt/Rate/Date',13,10 
		db '2. If Account Active="YES" the client',13,10
		db '   already has an existing loan',13,10
		db '3. Negative Stock will not be allowed',13,10
		db '4. If in Doubt: Only once Installment',13,10
		db '   values have been calculated, may',13,10
		db '   and can an invoice be generated',0
Error12 db 'Not an ACTIVE loan account',0	
Error13 db '  <<<  Invalid Payment Amount >>>  ',13,10
		db '  Payment amount must be in range  ',13,10 
		db 'Min Due >= Payment-Amount <= Max Due',0 
Error14 db 'Could not Authenticate - Please Retry',13,10
		db 'Enter valid Password in Box supplied ',0
Error15 db 'Please Start a Shift First',0
Error16 db 'Please Setup Branch First',0 
Error17 db 'Please Add an Account First',0 
;########################################################################
.code
RGB MACRO red, green, blue
	xor eax, eax
	mov al, blue    ; blue
	rol eax, 8
	mov al, green   ; green
	rol eax, 8
	mov al, red     ; red
ENDM
PadZero proc I_String:DWORD,O_String:DWORD,O_Bytes:DWORD
; adds leading '0' (zero) to a number string 
; invoke PadZero addr InString, addr OutString, 5 --> ex. '1' = '00001' 
	invoke szLen, I_String
	mov ecx, O_Bytes
	mov edi, O_String
	sub ecx, eax
	jbe Pad1
	mov al, '0'
	cld
	rep stosb
	xor al, al
	stosb 
	invoke szCatStr, O_String, I_String
	ret
Pad1:
	invoke szCopy, I_String, O_String
	ret
PadZero endp
PadNone proc SRCSTR:DWORD,DESTSTR:DWORD 
; remove unwanted chars from a string - see ValidCHAR 
; invoke PadNone addr InString, addr OutString --> ex.'a!B-5;0a' = 'aB5a' 
	pusha
	mov edi, DESTSTR
	mov esi, SRCSTR
	cld
Pad2:
	mov ecx, 36 
	mov ebx, offset ValidCHAR
Pad3:	
	lodsb
	test al, al
	jz Pad6
Pad4:	
	cmp al, byte ptr [ebx]
	je Pad5
	inc ebx
	loopnz Pad4
	jmp Pad2
Pad5:
	stosb	
	jmp Pad2
Pad6:
	stosb
	popa		
	ret
PadNone endp
AdmPassword proc WHandle : DWORD ; lame but works
	invoke GetDlgItemText,WHandle,1005,ADDR TmpString,	30
	test eax, eax
	jz AP_Exit
	invoke szCmp,ADDR TmpString,ADDR Password
	test eax, eax
	jz AP_Exit
	mov eax, TRUE
	ret
AP_Exit:
	invoke MessageBox,WHandle,ADDR Error14,ADDR ErrorA,MB_ICONSTOP
	mov eax, FALSE	
	ret
AdmPassword endp
;########################################################################
include PrintPre.asm
include Branch.asm
include Stock.asm
include Shift.asm
include Find.asm
include Edit.asm
include Transaction.asm
include ReportACC.asm
include StateRpt.asm
include Payment.asm
;########################################################################
start:
; if our app is already running - kill this started instance = GAtom
; not the right way to do it - but 'a way'
	invoke GlobalFindAtom, addr TitleMsg1
	.if ax==FALSE
		invoke GlobalAddAtom, addr TitleMsg1
		mov hAtom, eax
	.else
		jmp EndAPP
	.endif
	invoke GetModuleHandle,NULL
	mov	hInstance,eax
    invoke InitCommonControls
    mov	iccex.dwSize,sizeof INITCOMMONCONTROLSEX    
  	mov	iccex.dwICC,ICC_DATE_CLASSES ; ensure dateview class can display
	invoke InitCommonControlsEx,offset iccex
    invoke LoadLibrary,addr Richfile ; load external RichEdit LIB
	invoke DialogBoxParam,hInstance,Main_Select,NULL,addr DlgProc,NULL
	invoke GlobalDeleteAtom, hAtom
EndAPP:	
	invoke ExitProcess,0
;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps      : PAINTSTRUCT
	LOCAL	hDCpic  : HDC	; handle of DC we'll be using for Bitmap paint 
	LOCAL	memDC   : DWORD ; pointer to memory of DC control   
	 
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push hWin
		pop hWnd
		call LoadBrnch ; make sure we have a Branch & Stock file
		call LoadStock ; to work with else set Flags to start complaining
		call LoadAccnt ; about short-commings that need rectification
		invoke LoadBitmap,hInstance,301; Bitmap ref. in Resource file
		mov	RCBitmap,eax
	.elseif eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
	  	.if edx==BN_CLICKED
	  		.if	eax==1019      ; The admin selected Branch-Setup
	  			invoke AdmPassword,hWin
	  			test eax, eax
	  			jz DMain_Exit
				invoke DialogBoxParam,hInstance,Brnch_Select,hWin,addr BranchProc,NULL
			.elseif eax==1009  ; The admin selected Stock IN/OUT
				invoke AdmPassword,hWin
	  			test eax, eax
	  			jz DMain_Exit
				invoke DialogBoxParam,hInstance,Stock_Select,hWin,addr StockProc,NULL
			.elseif eax==1011  ; The admin selected Statement Report
			    invoke AdmPassword,hWin
	  			test eax, eax
	  			jz DMain_Exit
				invoke DialogBoxParam,hInstance,Prnt_Select,hWin,addr Printit,addr StatePrint
			.elseif eax==1013  ; The admin selected clear Password access
				invoke SetDlgItemText,hWin,1005,NULL		
			.elseif eax==1010  ; The user selected Shift Start/End
				invoke DialogBoxParam,hInstance,Shift_Select,hWin,addr ShiftProc,NULL
			.elseif eax==1001  ; The user selected ADD/EDIT client
				invoke DialogBoxParam,hInstance,Edit_Select,hWin,addr EditProc,NULL
			.elseif eax==1002  ; The user selected Loan Transaction
				invoke DialogBoxParam,hInstance,Trns_Select,hWin,addr TrnsProc,NULL
			.elseif eax==1003  ; The user selected Payment Transaction
				invoke DialogBoxParam,hInstance,Pay_Select,hWin,addr PayProc,NULL
			.elseif eax==1004  ; The user selected Account Report
				invoke DialogBoxParam,hInstance,ACC_Select,hWin,addr RPTProc,NULL
			.elseif eax==1012  ; The user selected About Box	
				invoke ShellAbout,hWin,addr TitleMsg1,addr TitleMsg2,NULL	
			.elseif eax==IDCANCEL ; The user selected Quit
				invoke MessageBox,hWin,addr Error7,addr ErrorA,MB_ICONEXCLAMATION or MB_YESNO
				test eax, IDOK
				jnz	DMain_Exit
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif	
	.elseif	eax==WM_PAINT
	    invoke BeginPaint,hWin,addr ps	; Tell Windows we wanna Paint 
	    mov		hDCpic,eax
	    invoke CreateCompatibleDC,hDCpic ; Create a device instance
	    mov		memDC,eax
	    invoke SelectObject,memDC, RCBitmap   
	    ; Create a memory pointer to the bitmap refrencing our 
	    ; resource defined bitmap. Then paint it using StretchBlt
	    ; for the area and size defined - see Win32.hlp for exact def. 
	    ; ( I shrunk the Bitmap for the area used - it can be bigger )
	    ; ( or smaller - use less or more colours etc. I just wanted )
	    ; ( the EXE size to stay smallish .... go figure  ;-)        ) 
	    invoke StretchBlt,hDCpic,155,195,140,90,memDC,0,0,140,90,SRCAND								
	    invoke EndPaint,hWin,addr ps	; Tell Windows we're done 		  
	    invoke DeleteDC,memDC			; Release the device instance
	.elseif eax==WM_CLOSE
		invoke DeleteObject,RCBitmap ; NB: Remember to release the memory
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
DMain_Exit:	
	mov		eax,TRUE
	ret
DlgProc endp
end start
