PayColumn Proc ; setup the list view headers and the look of report style
LOCAL lvs:LV_COLUMN
	mov lvs.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvs.pszText,offset Header1		; Invoice number
	mov lvs.lx,60		
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 0 ,addr lvs
	or  lvs.imask,LVCF_FMT
	mov lvs.fmt,LVCFMT_CENTER
	mov lvs.pszText,offset Header2		; Intstallment
	mov lvs.lx,90
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 1 ,addr lvs
	or  lvs.imask,LVCF_FMT
	mov lvs.fmt,LVCFMT_CENTER
	mov lvs.pszText,offset Header3		; Balance owed
	mov lvs.lx,90
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 2 ,addr lvs
	or  lvs.imask,LVCF_FMT
	mov lvs.fmt,LVCFMT_CENTER
	mov lvs.pszText,offset Header4		; Months left
	mov lvs.lx,75
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 3 ,addr lvs
	mov eax,  LVS_EX_GRIDLINES ;Just showing list/no interaction required
	invoke   SendMessage, hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
	invoke   SendMessage, hList, LVM_SETTEXTCOLOR, 0, 00000000h
	invoke   SendMessage, hList, LVM_SETBKCOLOR, 0, 00FFFFFFh
	invoke   SendMessage, hList, LVM_SETTEXTBKCOLOR, 0,00A477f0h
	ret
PayColumn  endp
SetPayList proc ; fill the list with data relevant to the selected 
				; account number as given in TmpString1 (SetPayClient)
	invoke CreateFile,ADDR Trnfile,GENERIC_READ,
	NULL,NULL,OPEN_ALWAYS,FILE_FLAG_SEQUENTIAL_SCAN,NULL
	mov FileHandle, eax
	mov lvi.iItem, 0
SP_Loop:	
	invoke ReadFile,FileHandle,ADDR T_Accno,128,ADDR ReadWrite,NULL
	.if ReadWrite == NULL || eax == NULL
		jmp SP_Exit1
	.endif	
	invoke szCmp, addr T_Accno, addr TmpString1
	test eax, eax		; if account(user select)=account(in file)
	jz SP_Loop			; use it else loose it ;-)
	mov lvi.iSubItem, 0 ; insert invoice number to list 
	invoke szCopy, addr T_Inv, addr TmpString
	invoke SetDlgItemText,hWnd,2122,addr TmpString	; inv #	
	invoke SendMessage,hList,LVM_INSERTITEM,0,addr lvi
	inc lvi.iSubItem	; insert installment to list
	invoke FpuFLtoA,addr T_Install,2,ADDR TmpString,SRC1_REAL or SRC2_DIMM
	invoke SetDlgItemText,hWnd,2114,addr TmpString	; installment
	invoke SendMessage,hList,LVM_SETITEM,0,addr lvi
	inc lvi.iSubItem    ; insert balance to list
	invoke FpuFLtoA,addr T_Owed,2,ADDR TmpString,SRC1_REAL or SRC2_DIMM
	invoke SetDlgItemText,hWnd,2118,addr TmpString	; tot.owed
	invoke SendMessage,hList,LVM_SETITEM,0,addr lvi	
	mov ebx, T_Months
	inc lvi.iSubItem	; insert months left to list
	invoke ltoa, ebx, addr TmpString
	invoke SetDlgItemText,hWnd,2120,addr TmpString	; months Left
	invoke SendMessage,hList,LVM_SETITEM,0,addr lvi
	invoke SetDlgItemText,hWnd,2124,addr T_D3	    ; payable date
	jmp SP_Loop
SP_Exit1:    
	invoke CloseHandle,FileHandle
	ret
SetPayList endp
SetPayClient proc
	mov ebx, cRecord  ; get the account details 
					  ;	under review and populate dialog
					  ; setup the paylist requirements (TmpString1)
assume ebx : ptr ACC_STRUC	
	invoke szCopy, addr [ebx].A_Accnum, addr TmpString1
	invoke SetDlgItemText,hWnd,2107,addr [ebx].A_Accnum
	invoke SetDlgItemText,hWnd,2108,addr [ebx].A_Surname
	invoke SetDlgItemText,hWnd,2109,addr [ebx].A_ID
	.if [ebx].A_Active==TRUE 
		invoke SetDlgItemText,hWnd,2116,ADDR Y_Yes
		mov AFlag, TRUE
	.else
		invoke SetDlgItemText,hWnd,2116,ADDR N_No
		mov AFlag, FALSE
	.endif	
assume ebx : NOTHING	
	ret
SetPayClient endp
EvalPay proc
LOCAL EMonths : DWORD
	mov TFlag, FALSE	; Flag = was total amount owed payed ?
	invoke GetDlgItemText,hWnd,2114,addr TmpString1, 16 ; min
	test eax, eax
	jz EP_Err1
	invoke GetDlgItemText,hWnd,2118,addr TmpString2, 16 ; max
	test eax, eax
	jz EP_Err1
	invoke GetDlgItemText,hWnd,2102,addr TmpString3, 16 ; pay amnt
	test eax, eax
	jz EP_Err1
	invoke GetDlgItemText,hWnd,2122,addr TmpString4, 16 ; inv numb
	test eax, eax
	jz EP_Err1	
	invoke GetDlgItemInt,hWnd,2120,NULL,FALSE  ; Months Left
	mov Months, eax	
	finit
	invoke FpuAtoFL, ADDR TmpString3 , ADDR TmpReal10, DEST_MEM
	test eax, eax
	jz EP_Err1
	invoke FpuExam,ADDR TmpReal10,SRC1_REAL ; is value Negative ?
	test eax, XAM_NEG or XAM_ZERO
	jnz  EP_Err1
	invoke FpuAtoFL, ADDR TmpString1 , NULL, DEST_FPU  
	invoke FpuComp,NULL,ADDR TmpReal10,SRC1_FPU or SRC2_REAL 
	; minimum due < pay amnt?
	test eax, eax
	jz	EP_Err1
	test eax, CMP_GREATER
	jnz	EP_Err1
	fstp st
	invoke FpuAtoFL, ADDR TmpString2 , NULL, DEST_FPU
	invoke FpuComp,NULL,ADDR TmpReal10,SRC1_FPU or SRC2_REAL
	; maximum due < pay amnt?  equals will go thru
	test eax, eax
	jz	EP_Err1
	test eax, CMP_LOWER
	jnz	EP_Err1
;------------------------------------------------------------------
	dec Months
	jnz EP_A
	inc Months
EP_A:
	fld TmpReal10      ; pay amount
	fsub		       ; maximum due <minus> pay amount = new due amount
	frndint
	invoke FpuExam,NULL,SRC1_FPU ; is value ZERO ?
	test eax, XAM_ZERO
	jnz EP_B
	fild dword ptr Months ; months left
	fdivr st(0), st(1) ; new due amount <div> months left = installment
	jmp EP_C
;------------------------------------------------------------------	
EP_B:
; Account Update
	mov ebx, cRecord
assume ebx : ptr ACC_STRUC		
	mov Months, 0
	mov byte ptr [ebx].A_Active, FALSE
	mov TFlag, TRUE
	fld st
assume ebx : NOTHING	
EP_C:	
; Brnch receipt update					
	invoke atodw,addr B_rctnum 
	inc eax
	invoke dw2a,eax, addr B_rctnum 
	call SaveBrnch
; Transaction Update
	invoke CreateFile,ADDR Trnfile,GENERIC_READ or GENERIC_WRITE,
	NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	mov FileHandle, eax
EP_Loop:	
	invoke ReadFile,FileHandle,ADDR T_Accno,128,ADDR ReadWrite,NULL
	.if ReadWrite == NULL || eax == NULL
		jmp EP_Err2
	.endif		
	invoke szCmp, addr T_Inv, addr TmpString4
	test eax, eax		; if invoice(user select)=invoice(in file) ?
	jz EP_Loop		
	invoke SetFilePointer,FileHandle,-128,NULL,FILE_CURRENT		
	invoke szCopy, addr B_rctnum , addr T_Receipt
	invoke szCopy, addr T_D3     , addr GDate
	m2m T_Months, Months
	fstp T_Install
	fstp T_Owed
;Calculate new next installment date (if required)	
	.if TFlag == FALSE
		invoke atodw  , addr GDate+4
		mov GDate+4, 0
		mov ebx    , eax  ; YEARS
		invoke atodw  , addr GDate+2
		inc eax		      ; MONTHS = MONTHS + 1
		cmp eax, 12
		jle EP_D
		mov eax, 1        ; If months > 12 - reset to 1 and	 
		inc ebx			  ; we changed to next calander year 
EP_D:	
		mov EMonths, eax	
		invoke dwtoa, 28      , addr TmpString	;ddMMyyyy
		invoke dwtoa, EMonths , addr TmpString1
		invoke dwtoa, ebx     , addr TmpString2
		invoke PadZero , addr TmpString1, addr TmpString3, 2
		invoke szCopy  , addr TmpString , addr GDate
		invoke szCatStr, addr GDate, addr TmpString3
		invoke szCatStr, addr GDate, addr TmpString2
		invoke szCopy  , addr GDate, addr T_D3
	.endif		
	invoke WriteFile,FileHandle,addr T_Accno,128,ADDR ReadWrite,NULL
	invoke CloseHandle, FileHandle
; Stock update	
	fld S_value
	fld TmpReal10
	fadd
	fstp S_value
	inc S_payment	; add 1 to number of payments in this shift
	call SaveStock
; Log update	
	invoke szCopy  , addr T_Receipt	  , addr LogItem
	invoke szCatStr, addr LogItem     , addr C_omma 
	invoke szCatStr, addr LogItem     , addr T_Accno
	invoke szCatStr, addr LogItem     , addr C_omma 
	invoke szCatStr, addr LogItem     , addr B_consultant
	call SetLog	
	mov eax, TRUE
	ret
;------------------------------------------------------------------	
EP_Err1:
	invoke MessageBox,hWnd,addr Error13,addr ErrorA,MB_ICONSTOP
	mov eax, FALSE		
	ret
EP_Err2:
	invoke MessageBox,hWnd,addr Error8,addr ErrorA,MB_ICONSTOP	
	invoke CloseHandle, FileHandle
	mov eax, FALSE	
	ret
EvalPay endp
PayProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		push hWin
		pop  hWnd
		.if B_shift == FALSE  ; Shift in progress ?
			invoke MessageBox,hWnd,addr Error15,addr ErrorA,MB_ICONEXCLAMATION
			jmp P_Exit2
		.elseif IAccnt == FALSE ; At least 1 record in Account File ?
			invoke MessageBox,hWnd,addr Error17,addr ErrorA,MB_ICONEXCLAMATION
			jmp P_Exit2
		.endif
		call OpenMemMapAccFile ; open account file into memory map view
		test eax, eax		   ; if fail=false were in trouble
		jz P_Exit2
		invoke GetDlgItem,hWin,2110 ; set the list handle 
		mov hList, eax
		call GetACCcount
		call PayColumn
		invoke GetDateFormat,NULL,NULL,NULL,offset BDate,offset CDate,10
		mov TFlag, FALSE
		mov AFlag, FALSE
	.elseif eax==WM_CTLCOLORSTATIC ; set colours for static cntrl items
			invoke GetDlgCtrlID,lParam
			.if eax==2101 || eax==2104 || eax==2105 || eax==2106
				RGB 255,0,0
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH	
			.elseif eax==2107 || eax==2108 || eax==2109
				RGB 55,255,0
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH	
			.elseif eax==2111
				RGB 255,128,255
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH		
			.else
				mov eax,FALSE
			.endif	
			ret	
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==2103 ; user selected find account
				invoke SendMessage,hList,LVM_DELETEALLITEMS,NULL,NULL
				invoke DialogBoxParam,hInstance,Find_Select,hWin,addr FindProc,NULL
				call SetPayClient
				call SetPayList
			.elseif eax==2112 ; user selected print receipt
				.if AFlag==TRUE
					call EvalPay
					test eax, eax
					jz P_Exit3
					invoke DialogBoxParam,hInstance,Prnt_Select,hWin,addr Printit,addr pPAYMENT
					invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL 
				.else
					invoke MessageBox,hWin,addr Error12,addr ErrorA,MB_ICONSTOP	
				.endif 	
			.elseif eax==IDCANCEL ; user selected exit
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif	
		.endif
	.elseif	eax==WM_CLOSE
P_Exit1:	
		call CloseMemMapAccFile ; save the account file / update
P_Exit2:	
		invoke	EndDialog,hWin,0
	.else
		xor eax, eax
		ret
	.endif	
P_Exit3:		
	mov eax, TRUE
	ret	
PayProc	 endp